Overview | Package | Class | Tree | Deprecated | Index | Help
| Apache JMeter
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.jmeter.gui
Interface JMeterGUIComponent

All Known Implementing Classes:
  AbstractJMeterGuiComponent, HttpMirrorControlGui, NamePanel, ProxyControlGui, TestBeanGUI

public interface JMeterGUIComponent

Implementing this interface indicates that the class is a JMeter GUI Component. A JMeter GUI Component is essentially the GUI display code associated with a JMeter Test Element. The writer of the component must take care to make the component be consistent with the rest of JMeter's GUI look and feel and behavior. Use of the provided abstract classes is highly recommended to make this task easier.

See Also:
  `AbstractJMeterGuiComponent`, `AbstractConfigGui`, `AbstractAssertionGui`, `AbstractControllerGui`, `AbstractTimerGui`, `AbstractVisualizer`, `AbstractSamplerGui`

Method Summary
`void` | `clearGui()` Clear the gui and return it to initial default values.
`void` | `configure(TestElement element)` The GUI must be able to extract the data from the TestElement and update all GUI fields to represent those data.
`JPopupMenu` | `createPopupMenu()` When a user right-clicks on the component in the test tree, or selects the edit menu when the component is selected, the component will be asked to return a JPopupMenu that provides all the options available to the user from this component.
`TestElement` | `createTestElement()` JMeter test components are separated into a model and a GUI representation.
`String` | `getDocAnchor()` Get the component's document anchor name.
`String` | `getLabelResource()` Get the component's resource name, which getStaticLabel uses to derive the component's label in the local language.
`Collection` | `getMenuCategories()` This is the list of add menu categories this gui component will be available under.
`String` | `getName()` Gets the name of the JMeter GUI component.
`String` | `getStaticLabel()` Get the component's label.
`boolean` | `isEnabled()` Test GUI elements can be disabled, in which case they do not become part of the test when run.
`void` | `modifyTestElement(TestElement element)` GUI components are responsible for populating TestElements they create with the data currently held in the GUI components.
`void` | `setEnabled(boolean enabled)` Set whether this component is enabled.
`void` | `setName(String name)` Sets the name of the JMeter GUI Component.
`void` | `setNode(TreeNode node)` Sets the tree node which this component is associated with.

Method Detail

### setName

    public void setName(String name)

  Sets the name of the JMeter GUI Component. The name of the component is used in the Test Tree as the name of the tree node.

  Parameters:
    `name` - the name of the component

### getName

    public String getName()

  Gets the name of the JMeter GUI component. The name of the component is used in the Test Tree as the name of the tree node.

  Returns:
    the name of the component

### getStaticLabel

    public String getStaticLabel()

  Get the component's label. This label is used in drop down lists that give the user the option of choosing one type of component in a list of many. It should therefore be a descriptive name for the end user to see. It must be unique to the class. It is also used by Help to find the appropriate location in the documentation. Normally getLabelResource() should be overridden instead of this method; the definition of this method in AbstractJMeterGuiComponent is intended for general use.

  Returns:
    GUI label for the component.
  See Also:
    `getLabelResource()`

### getLabelResource

    public String getLabelResource()

  Get the component's resource name, which getStaticLabel uses to derive the component's label in the local language. The resource name is fixed, and does not vary with the selected language. Normally this method should be overriden in preference to overriding getStaticLabel(). However where the resource name is not available or required, getStaticLabel() may be overridden instead.

  Returns:
    the resource name

### getDocAnchor

    public String getDocAnchor()

  Get the component's document anchor name. Used by Help to find the appropriate location in the documentation

  Returns:
    Document anchor (#ref) for the component.

### createTestElement

    public TestElement createTestElement()

  JMeter test components are separated into a model and a GUI representation. The model holds the data and the GUI displays it. The GUI class is responsible for knowing how to create and initialize with data the model class that it knows how to display, and this method is called when new test elements are created.

  Returns:
    the Test Element object that the GUI component represents.

### modifyTestElement

    public void modifyTestElement(TestElement element)

  GUI components are responsible for populating TestElements they create with the data currently held in the GUI components. This method should overwrite whatever data is currently in the TestElement as it is called after a user has filled out the form elements in the gui with new information.

  Parameters:
    `element` - the TestElement to modify

### isEnabled

    public boolean isEnabled()

  Test GUI elements can be disabled, in which case they do not become part of the test when run.

  Returns:
    true if the element should be part of the test run, false otherwise

### setEnabled

    public void setEnabled(boolean enabled)

  Set whether this component is enabled.

  Parameters:
    `enabled` - true for enabled, false for disabled.

### createPopupMenu

    public JPopupMenu createPopupMenu()

  When a user right-clicks on the component in the test tree, or selects the edit menu when the component is selected, the component will be asked to return a JPopupMenu that provides all the options available to the user from this component.

  Returns:
    a JPopupMenu appropriate for the component.

### configure

    public void configure(TestElement element)

  The GUI must be able to extract the data from the TestElement and update all GUI fields to represent those data. This method is called to allow JMeter to show the user the GUI that represents the test element's data.

  Parameters:
    `element` - the TestElement to configure

### getMenuCategories

    public Collection getMenuCategories()

  This is the list of add menu categories this gui component will be available under. For instance, if this represents a Controller, then the MenuFactory.CONTROLLERS category should be in the returned collection. When a user right-clicks on a tree element and looks through the "add" menu, which category your GUI component shows up in is determined by which categories are returned by this method. Most GUI's belong to only one category, but it is possible for a component to exist in multiple categories.

  Returns:
    a Collection of Strings, where each element is one of the constants defined in MenuFactory
  See Also:
    `MenuFactory`

### setNode

    public void setNode(TreeNode node)

  Sets the tree node which this component is associated with.

  Parameters:
    `node` - the tree node corresponding to this component

### clearGui

    public void clearGui()

  Clear the gui and return it to initial default values. This is necessary because most gui classes are instantiated just once and re-used for multiple test element objects and thus they need to be cleared between use.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Apache JMeter
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1998-2009 Apache Software Foundation. All Rights Reserved.